elseif handles.D.stffmodel==3
    %This are unknown parameters (variables) that are being fit by a least 
    %squares curve fit.
    % x(1) - Linear initial slope
    % x(2) - Linear initial adjustment (y-axis intersection of the line 
             %that describes the non-contact regime)
    % x(3) - Contact Point
    % x(4) - Coefficient of the contact model
    % x(5) - Initial point along x-axis of the 
    % x(6) - Linear final slope
    
    %This is the initial guess for these values, based on the extension
    %curve
    x0=[p(1) p(2) EXTx(gtE0(end))-5 0.02 EXTx(pltend) 6];
    
    %These are the lower and upper bounds. They have been selected
    %arbitrarily, from practice, but do have a big impact on the fit.
    %EXTx(gtE0(end))-125
    lb=[-Inf -Inf mean([EXTx(1) xf(3)]) -Inf EXTx(gtE0(end)) -Inf];
    up=[Inf Inf EXTx(gtE0(end)) Inf EXTx(pltend) Inf];
    
    
    
    %This is the function that will be fit
    if handles.D.cnt_dist_menu==1
        func=@(x,xdata)(x(1)*xdata+x(2))+(x(4).*(xdata-x(3)).^(2).*(fHside(x(5)-xdata)-fHside(x(3)-xdata)))+(fHside(xdata-x(5)).*((x(6).*(xdata-x(5)))+(x(4).*((x(5)-x(3)).^2))));
    elseif handles.D.cnt_dist_menu==2
        func=@(x,xdata)(x(1)*xdata+x(2))+(x(4).*(xdata-x(3)).^(2).*(fHside((x(3)+handles.D.fitrngprcnt)-xdata)-fHside(x(3)-xdata)))+(fHside(xdata-(x(3)+handles.D.fitrngprcnt)).*((x(6).*(xdata-(x(3)+handles.D.fitrngprcnt)))+(x(4).*(((x(3)+handles.D.fitrngprcnt)-x(3)).^2))));
    end
    
    %The least squares curve fit of the filtered data
    opts = optimset('Display','off','TolFun',1e-8,'TolX',1e-8);   %do not output a writeup
    [xf, resnorm,residual]=lsqcurvefit(func,x0,EXTx,aaEXTy,lb,up,opts);
    if handles.D.cnt_dist_menu==2
        xf(5)=xf(3)+handles.D.fitrngprcnt;
    end
    resnorm=sqrt(mean(residual.^2));
    parameter = 4/3 * (1/(1-handles.D.neu^2)) * sqrt(handles.D.rval);
    ContactPoint=xf(3);
    YoungsMod=xf(4)/(parameter*10^(-6));
    
    %Check to see if curve fits well, ignore the curve if it doesn't
    if resnorm > handles.D.Stiff_Filt_Threshold && handles.D.filt_stiff==1
        Checknrm=0;
        YoungsMod=0;
        Curvenotes=[Curvenotes 'The Extension Curve does not agree with the stiffness model: all calculations were skipped\n'];
    end
%4TH OR LATER CUSTOM MODELS HERE