%Kostyantyn Partola
%FRAME Parameter reading file v1.6

% Update handles structure

if loadmethod==1
    u='WorkingParameters';
elseif loadmethod==2
    [Savename Savepath]=uigetfile('*.mat');
    u=[Savepath Savename];
end

D=load(u);

%check box for flattening
set(handles.fltn_check,'Value',D.fltn)                    %saves & updates

%chech box for stiffness
set(handles.stff_check,'Value',D.do_stff)                 %saves & updates

%check box for adhesion
set(handles.adhs_check,'Value',D.do_adhs)                 %saves & updates

%dropdown menu for handling multiple breaks
set(handles.MultiBreakBehaviourMenu,'Value',D.mbhandle)   %saves & updates

%dropdown menu for k-eff handling
set(handles.KeffMenu,'Value',D.keffprops)                 %saves & updates

%dropdown menu for the k-eff fit model
set(handles.keff_fit_box,'Value',D.keffmodel)             %saves & updates

%dropdown menu for stiffness fit model
set(handles.stff_model_menu,'Value',D.stffmodel)          %saves & updates

%dropdown menu for stiffness distance method
set(handles.cnt_dist_menu,'Value',D.cnt_dist_menu)        %saves & updates
if D.cnt_dist_menu==1
    set(handles.text5,'String','Ratio of Contact Max Fit:')
elseif D.cnt_dist_menu==2
    set(handles.text5,'String','Contact Fit Distance (nm):')
end

%Maximum distance from contact
Llim_str=num2str(D.Llim*10^9);                    %note unit change
set(handles.LLim_box,'String',Llim_str)                 %saves & updates

%Flattening length parameter box
freeairprcnt_str=num2str(D.freeairprcnt);
set(handles.fltn_box,'String',freeairprcnt_str)         %saves & updates

%Minimum steepness slope parameter box
jmpminslope_str=num2str(D.jmpminslope);
set(handles.min_steep_box,'String',jmpminslope_str)     %saves & updates

%K-eff measurement distance box
keffdist_str=num2str(D.keffdist);
set(handles.keff_dist_box,'String',keffdist_str)        %saves & updates

%WLC fit distance box
wlcdist_str=num2str(D.wlcdist);
set(handles.wlc_dist,'String',wlcdist_str)        %saves & updates

%Temperature box
T_box_str=num2str(D.T_box);
set(handles.T_box,'String',T_box_str)        %saves & updates

%Maximum k-eff box
keffmax_str=num2str(D.keffmax);
set(handles.maxkeff_box,'String',keffmax_str)           %saves & updates

%Neu number box
neu_str=num2str(D.neu);
set(handles.nue_box,'String',neu_str)                   %saves & updates

%Sphere radius box
rval_str=num2str(D.rval);                    %note unit change
set(handles.rval_box,'String',rval_str)                 %saves & updates

%Noise sensitivity box
sensitivity_str=num2str(D.sensitivity);
set(handles.sensitivity_box,'String',sensitivity_str)   %saves & updates

%Theta value box
theta_str=num2str(D.theta);
set(handles.theta_box,'String',theta_str)               %saves & updates

%Cutoff for Forces that are too large box
toohigh_str=num2str(D.toohigh*10^12);                   %note unit change
set(handles.maxFcutoff_box,'String',toohigh_str)        %saves & updates

%Y-axis max percentage for a stiffness fit
fitrngprcnt_str=num2str(D.fitrngprcnt);
set(handles.y_raise_percentage_box,'String',fitrngprcnt_str)    %saves & updates

%Maximum x-length to combine a small drop box
MaxCombineL_str=num2str(D.MaxCombineL*10^9);                      %note unit change
set(handles.MaxCombineL_box,'String',MaxCombineL_str)           %saves & updates

%Maximum ratio to combine noisy breaks box
MaxCombineR_str=num2str(D.MaxCombineR);
set(handles.MaxCombineR_box,'String',MaxCombineR_str)           %saves & updates

%Set the automatic scan rate
AutoScanSec_str=num2str(D.AutoScanSec);
set(handles.autoscansec,'String',AutoScanSec_str)           %saves & updates


%read min L-dist
Min_Ldist_str=num2str(D.MinLdist*(10^9));
set(handles.min_L_dist_box,'String',Min_Ldist_str)

%Contact Point dropbox
set(handles.Contact_Point_Menu,'Value',D.Contact_Point_Menu)

%Stiffness Filtering Checkbox
set(handles.stiff_curve_filt_checkbox,'Value',D.filt_stiff)

%Resnorm Threshold
Resnorm_thresh_str=num2str(D.Stiff_Filt_Threshold);
set(handles.Stiff_Filt_Threshold,'String',Resnorm_thresh_str)

%Break Detection Method
set(handles.Brkdetect_Menu,'Value',D.Brkdetect_Menu)
if D.Brkdetect_Menu==1
    set(handles.text12,'String','Noise Sensitivity:')
elseif D.Brkdetect_Menu==2
    set(handles.text12,'String','Minimum Break Force (pN):')
end

try
    D.FCnumber=handles.D.FCnumber;
end

try
    D.currentcurve=handles.D.currentcurve;
catch err
    D.currentcurve=1;
end

D.autorun=0;
handles.D=D;
guidata(hObject, handles);



