%Kostyantyn Partola
%FRAME Text Data Loader v1.6

%preparing variables for a new run
currentcurve=1;

%getting the input path for the file
%Foldpath=get(handles.CurvesPath,'String');
[Filename, Foldpath]=uigetfile({'*.txt'; '*.dat'; '*.csv';'*.*'});
Fullpath=[Foldpath Filename];
set(handles.Loading_Text,'String','Reading Data')
drawnow
%IBWlist=getAllFiles(Foldpath);  %this function can be found on Mathworks
F=importdata(Fullpath,'\t',1);
c=size(F.data);
n=0;
FCnumber=num2str(c(2));

%scanning through each file
for n=1:1:(c(2)/2)
    yref=2*n;
    xref=yref-1;
    x=F.data(:,xref);
    y=F.data(:,yref);
    x(isnan(x))=[];
    y(isnan(y))=[];
    [maxx, imaxx]=max(x);
    DataFile{n,1}=x;                            %Zsnsr, or x data
    DataFile{n,2}=y;                            %Force response, or y data
    DataFile{n,3}=1;                            %Spring Constant
    DataFile{n,4}=imaxx;                        %Where the wave flips
    DataFile{n,5}=F.colheaders{yref};           %Name of file
    DataFile{n,6}=xref;                         %X position
    DataFile{n,7}=yref;                         %Y position
    DataFile{n,8}=maxx;                         %The deepest indentation
end

%Making sure not to save a string for FCnumber
FCnumber=n;

%Saving the Data File and Important Variables
handles.DataFile=DataFile;
handles.D.FCnumber=FCnumber;
handles.D.currentcurve=1;
handles.D.autorun=0;
handles.D.DoManual=0;

%Display currentcurve value
set(handles.crv_numb_box,'String',num2str(handles.D.currentcurve))
set(handles.crv_num_display,'String',['Curve ' num2str(handles.D.currentcurve) ' of ' num2str(handles.D.FCnumber)])

%Initiating a new record
for k=1:FCnumber
    Record(k).CurveNumber=[];
    Record(k).Force=[];
    Record(k).YoungsMod=[];
    Record(k).Keff=[];
    Record(k).Persistence_L=[];
    Record(k).Contour_L=[];
    Record(k).Steepness=[];
    Record(k).Ldistance=[];
    Record(k).Breaklength=[];
    Record(k).ContactPoint=[];
    
    %the following are variables used in the Manual Mode
    Record(k).mMode=0;
    Record(k).linfx=[];
    Record(k).func=[];
    Record(k).xf=[];
    Record(k).pltend=[];
    Record(k).brkend=[];
    Record(k).brkstrt=[];
    Record(k).grtzero=[];
    Record(k).dstt=[];
    Record(k).peff=[];
    Record(k).mflt=[];
end
handles.Record=Record;

%Update the parameters and plot the first curve
LoadingMessage=['Finished Loading ' num2str(FCnumber) ' Curves'];
set(handles.Loading_Text,'String',LoadingMessage)
drawnow
guidata(hObject, handles);
fPlotting
