%Kostyantyn Partola
%FRAME Manual plotting and computation file v1.6

Curvenotes='Curve Notes:\n';

%Converting the curve to plotting coordinates
EXTx=EXTx.*10^9;
EXTy=EXTy.*10^12;

RETx=RETx.*10^9;
RETy=RETy.*10^12;

%reading the old axes in case user was zoomed in and trying to do unbinding
%event selection.
axes(handles.axes1)
shift=0;

if isempty(handles.Record(handles.D.currentcurve).linfx)==0
    po=handles.Record(handles.D.currentcurve).linfx;
    olinfx=@(x)(po(1).*x)+po(2);
end


%Flatten if flattened before
if (handles.D.DoManual==1 && firstrun==1) && (handles.D.fltn==1 || handles.D.do_stff==1)
else
    if isempty(handles.Record(handles.D.currentcurve).linfx)==0
        RETy=RETy-olinfx(RETx);
        EXTy=EXTy-olinfx(EXTx);
        shift=1;
    elseif isempty(handles.Record(handles.D.currentcurve).ContactPoint)==0
        Fcur=handles.Record(handles.D.currentcurve).ContactPoint;
        RETy=RETy-EXTy(Fcur);
        EXTy=EXTy-EXTy(Fcur);
        shift=1;
    end
end

if handles.D.DoManual==1
    plot(RETx,RETy,'b','LineWidth',1)
    hold on
    plot(EXTx,EXTy,'r','LineWidth',1)
    
    
    %Plotting unbinding events
    breaks=length(handles.Record(handles.D.currentcurve).Force);
    for pc=1:breaks
        brkstrt=handles.Record(handles.D.currentcurve).brkstrt(pc);
        brkend=handles.Record(handles.D.currentcurve).brkend(pc);
        dstt=handles.Record(handles.D.currentcurve).dstt(pc);
        peff=handles.Record(handles.D.currentcurve).peff(pc,:);
        plot(RETx(brkstrt:brkend),RETy(brkstrt:brkend),'m','LineWidth',1)
        plot(RETx(handles.Record(handles.D.currentcurve).grtzero),RETy(handles.Record(handles.D.currentcurve).grtzero),'o','Color',[1 0.35 0])
        plot(RETx(handles.Record(handles.D.currentcurve).grtzero),RETy(handles.Record(handles.D.currentcurve).grtzero),'x','Color',[1 0.35 0])
        %Xkeff=RETx(dstt:brkstrt);
        %LINy=polyval(peff,Xkeff);
        %plot(Xkeff,LINy,'Color',[0.2 0.95 0.65],'LineWidth',1)
    end
    
    %setting axes
    xmax=max([max(RETx) max(EXTx)]);
    xmin=min([min(RETx) min(EXTx)]);
    ymax=max([max(RETy) max(EXTy)]);
    ymin=min([min(RETy) min(EXTy)]);
    axis([xmin xmax ymin ymax])
    set(gca,'xdir','reverse')
    title([handles.DataFile{handles.D.currentcurve,5}],'Interpreter', 'none');
    xlabel('Z-sensor (nm)')
    ylabel('Force (pN)')
    hold off
    drawnow
    hold off
    %If the user is doing manual selection of something from "Manual Mode" the
    %code will prompt inputs, otherwise it will plot previously selected
    %measurements.
    
    if firstrun==1 && handles.D.fltn==1
        cent=mean([orig_axis(1) orig_axis(2)]);
        orig_axis(3)=orig_axis(3)+olinfx(cent);
        orig_axis(4)=orig_axis(4)+olinfx(cent);
    end
    
    handles.D.DoManual=0;
    guidata(hObject, handles);
    
    axes(handles.axes1)
    
    %if a new flattenning and not doing stiffness
    if handles.D.fltn==1 && handles.D.do_stff==0 && firstrun==1
        %flattening point
        set(handles.Loading_Text,'String','Please select a point close to the end of the non-contact region')
        drawnow
        datapoints=myginput(1);
        Fcur = dsearchn([EXTx EXTy],datapoints);
        p=polyfit(EXTx(1:Fcur),EXTy(1:Fcur),1);
        linfx=@(x)(p(1).*x)+p(2);
        
        RETy=RETy-linfx(RETx);
        EXTy=EXTy-linfx(EXTx);
        
        handles.Record(handles.D.currentcurve).linfx=p;
        guidata(hObject, handles);
        
        plot(RETx,RETy,'b','LineWidth',1)
        hold on
        plot(EXTx,EXTy,'r','LineWidth',1)
        xmax=max([max(RETx) max(EXTx)]);
        xmin=min([min(RETx) min(EXTx)]);
        ymax=max([max(RETy) max(EXTy)]);
        ymin=min([min(RETy) min(EXTy)]);
        axis([xmin xmax ymin ymax])
        set(gca,'xdir','reverse')
        title([handles.DataFile{handles.D.currentcurve,5}],'Interpreter', 'none');
        xlabel('Z-sensor (nm)')
        ylabel('Force (pN)')
        hold off
        drawnow
        hold off
        shift=1;
    end
    
    if handles.D.do_stff==1
        
        %contact point
        set(handles.Loading_Text,'String','Please select the contact point')
        drawnow
        datapoints=myginput(1);
        Fcur = dsearchn([EXTx EXTy],datapoints);
        p=polyfit(EXTx(1:Fcur),EXTy(1:Fcur),1);
        linfx=@(x)(p(1).*x)+p(2);
        if handles.D.fltn==1
            RETy=RETy-linfx(RETx);
            EXTy=EXTy-linfx(EXTx);
            handles.Record(handles.D.currentcurve).linfx=p;
            guidata(hObject, handles);
        else
            RETy=RETy-EXTy(Fcur);
            EXTy=EXTy-EXTy(Fcur);
        end
        
        
        plot(RETx,RETy,'b','LineWidth',1)
        hold on
        plot(EXTx,EXTy,'r','LineWidth',1)
        xmax=max([max(RETx) max(EXTx)]);
        xmin=min([min(RETx) min(EXTx)]);
        ymax=max([max(RETy) max(EXTy)]);
        ymin=min([min(RETy) min(EXTy)]);
        axis([xmin xmax ymin ymax])
        plot(EXTx(Fcur),EXTy(Fcur),'kx')
        plot(EXTx(Fcur),EXTy(Fcur),'ko')
        set(gca,'xdir','reverse')
        title([handles.DataFile{handles.D.currentcurve,5}],'Interpreter', 'none');
        xlabel('Z-sensor (nm)')
        ylabel('Force (pN)')
        drawnow
        shift=1;
        
        
        %plothere
        set(handles.Loading_Text,'String','Please select the end of the contact model fit point')
        drawnow
        datapoints=myginput(1);
        pltend = dsearchn([EXTx EXTy],datapoints);
        plot(EXTx(pltend),EXTy(pltend),'gx')
        plot(EXTx(pltend),EXTy(pltend),'go')
        hold off
        
        %This are unknown variables that are being fit by a least squares
        %curve fit.
        % 1 - Coefficient
        
        Checknrm=1;
        trigsame=0;
        %This is the initial guess for these values, based on the extension
        %curve
        x0=2;
        
        %These are the variables important to the lsqcurvefit function
        lb=-Inf;
        up=Inf;
        
        if handles.D.stffmodel==1
            if trigsame==0;
                ConP=EXTx(Fcur);
                StpP=EXTx(pltend);
                func=@(x,xdata)x.*((xdata-ConP).^(2));
                
                opts = optimset('Display','off');   %do not output a writeup
                [xf, resnorm]=lsqcurvefit(func,x0,EXTx(Fcur:pltend),EXTy(Fcur:pltend),lb,up,opts);
                parameter = 3/4 * 1/(1-handles.D.neu^2) * tan(handles.D.theta);
                ContactPoint=Fcur;
                YoungsMod=xf/(parameter*10^(-6));
            else
                Checknrm=0;
                Curvenotes=[Curvenotes 'The Extension Curve does not agree with the stiffness model: all calculations were skipped\n'];
                handles.D.do_stff=0;
                YoungsMod=0;
            end
        elseif handles.D.stffmodel==2
            if trigsame==0;
                ConP=EXTx(Fcur);
                StpP=EXTx(pltend);
                func=@(x,xdata)x.*((xdata-ConP).^(3/2));
                
                opts = optimset('Display','off');   %do not output a writeup
                [xf, resnorm]=lsqcurvefit(func,x0,EXTx(Fcur:pltend),EXTy(Fcur:pltend),lb,up,opts);
                parameter = 4/3 * 1/(1-handles.D.neu^2) * sqrt(handles.D.rval);
                ContactPoint=Fcur;
                YoungsMod=xf/(parameter*10^(-6));
                
                hold on
                plot(EXTx,func(xf,EXTx),'k','LineWidth',1.5);
                drawnow
                hold off
            else
                Checknrm=0;
                Curvenotes=[Curvenotes 'The Extension Curve does not agree with the stiffness model: all calculations were skipped\n'];
                handles.D.do_stff=0;
                YoungsMod=0;
            end
        %PASTE fCustom_model_statement.m HERE
        end
        
        handles.Record(handles.D.currentcurve).YoungsMod=YoungsMod;
        handles.Record(handles.D.currentcurve).ContactPoint=ContactPoint;
        handles.Record(handles.D.currentcurve).func=func;
        handles.Record(handles.D.currentcurve).xf=xf;
        handles.Record(handles.D.currentcurve).pltend=pltend;
        guidata(hObject, handles);
    end
    
    if handles.D.do_adhs==1
        if isempty(handles.Record(handles.D.currentcurve).Force)==1 || handles.Record(handles.D.currentcurve).Force(1)==0
            %starting point for L-dist
            xmax=max([max(RETx) max(EXTx)]);
            xmin=min([min(RETx) min(EXTx)]);
            ymax=max([max(RETy) max(EXTy)]);
            ymin=min([min(RETy) min(EXTy)]);
            axis([xmin xmax ymin ymax])
            
            set(handles.Loading_Text,'String','Please select the L-Distance starting point')
            drawnow
            datapoints=myginput(1);
            grtzero = dsearchn([RETx RETy],datapoints);
            hold on
            plot(RETx(grtzero),RETy(grtzero),'o','Color',[1 0.35 0])
            plot(RETx(grtzero),RETy(grtzero),'x','Color',[1 0.35 0])
            drawnow
            axis([xmin xmax ymin ymax])
            hold off
            %plothere
            
            %fixing the window
            if shift==1;
                if isempty(handles.Record(handles.D.currentcurve).linfx)==0
                    po=handles.Record(handles.D.currentcurve).linfx;
                    nlinfx=@(x)(po(1).*x)+po(2);
                    orig_axis(3)=orig_axis(3)-(max([nlinfx(orig_axis(1)) nlinfx(orig_axis(2))]));
                    orig_axis(4)=orig_axis(4)-(min([nlinfx(orig_axis(1)) nlinfx(orig_axis(2))]));
                elseif isempty(handles.Record(handles.D.currentcurve).ContactPoint)==0
                    Fcur=handles.Record(handles.D.currentcurve).ContactPoint;
                    orig_axis(3)=orig_axis(3)-EXTy(Fcur);
                    orig_axis(4)=orig_axis(4)-EXTy(Fcur);
                end
            end
            
            
            %unbinding event point
            set(handles.Loading_Text,'String','Please select the unbinding event points')
            drawnow
            axes(handles.axes1)
            axis(orig_axis)
            datapoints=myginput(1);
            k = dsearchn([RETx RETy],datapoints);
            hold on
            plot(RETx(k),RETy(k),'mo')
            plot(RETx(k),RETy(k),'mx')
            drawnow
            hold off
            datapoints=myginput(1);
            k(2) = dsearchn([RETx RETy],datapoints);
            if k(2)<k(1)
                k=wrev(k);
            end
            
            %keff
            dend=k(1);
            found=0;
            pc=dend;                            %pointcheck
            while found==0
                pc=pc-1;
                if pc==0
                    found=1;
                    dstt=1;
                    pc=1;
                end
                dstback=RETx(pc)-RETx(dend);
                if (dstback)>handles.D.keffdist
                    found=1;
                    dstt=pc;
                end
            end
            peff=polyfit(RETx(dstt:dend),RETy(dstt:dend),1);
            
            %Bringing all data into proper units
            FDiff=RETy(k(2))-RETy(k(1));
            Keff=peff(1);
            
            %WLC Model
            if handles.D.keffmodel==2
                dend=k(1);
                found=0;
                pc=dend;                            %pointcheck
                
                %Finding the distance back from each unbinding event that is
                %either the input distance or the previous unbinding event.
                while found==0
                    pc=pc-1;
                    if pc==0
                        found=1;
                        dstt=1;
                        pc=1;
                    elseif pc==grtzero(1)
                        found=1;
                        dstt=pc+1;
                    end
                    dstback=RETx(pc)-RETx(dend);
                    if (dstback)>handles.D.wlcdist
                        found=1;
                        dstt=pc;
                    end
                end
                
                %Data to fit
                xdfit=(RETx(grtzero(1))-RETx(dstt:dend));
                fdfit=RETy(grtzero(1))-(RETy(dstt:dend));
                %Constants
                kb=1.3806488*10^(-2);
                T=305.15;
                
                %Initial guess, and bounds for the persistence length
                %and countour length, L(1) and L(2) respectively
                Li=[xdfit(end)/10 abs(xdfit(end))*1.05];
                Llb=[0 xdfit(end)];
                Lub=[xdfit(end) xdfit(end)*2];
                
                %WLC and curvefit
                wlcfunc=@(L,xd)((kb.*T)./L(1)).*((1./(4.*(1-(xd./L(2))).^2))-(1./4)+(xd./L(2)));
                opts = optimset('Display','off','TolFun',1e-7,'TolX',1e-7);   %do not output a writeup
                Lf=lsqcurvefit(wlcfunc,Li,xdfit,fdfit,Llb,Lub,opts);
                
                handles.Record(handles.D.currentcurve).Persistence_L=Lf(1);
                handles.Record(handles.D.currentcurve).Contour_L=Lf(2);
                
                WLCxspace=linspace(RETx(grtzero(1)),RETx(dstt));
                WLCfuncspace=linspace(0,RETx(grtzero(1))-RETx(dstt));
                WLCresult=RETy(grtzero(1))-wlcfunc(Lf,WLCfuncspace);
                
                WLCxspace_2=linspace(RETx(dstt),RETx(dend));
                WLCfuncspace_2=linspace(RETx(grtzero(1))-RETx(dstt),RETx(grtzero(1))-RETx(dend));
                WLCresult_2=RETy(grtzero(1))-wlcfunc(Lf,WLCfuncspace_2);
                
                %K-Eff calculation
                distb=handles.D.keffdist;
                dbcto=WLCxspace_2(end)+distb;
                LinLi=WLCxspace_2<dbcto;
                
                keff_xsp=WLCxspace_2(LinLi);
                keff_ysp=WLCresult_2(LinLi);
                
                Keff=(keff_ysp(1)-keff_ysp(end))/(keff_xsp(1)-keff_xsp(end));
            end
            
            Ldistance=RETx(grtzero)-RETx(k(1));
            Steepness=((RETy(k(2))-RETy(k(1)))/(-RETx(k(2))+RETx(k(1))))*1000;
            Breaklength=(-RETx(k(2))+RETx(k(1)));
            brkend=k(2);
            brkstrt=k(1);
            
            handles.Record(handles.D.currentcurve).CurveNumber=handles.D.currentcurve;
            handles.Record(handles.D.currentcurve).Force=FDiff;
            handles.Record(handles.D.currentcurve).Keff=Keff;
            handles.Record(handles.D.currentcurve).Steepness=Steepness;
            handles.Record(handles.D.currentcurve).Ldistance=Ldistance;
            handles.Record(handles.D.currentcurve).Breaklength=Breaklength;
            handles.Record(handles.D.currentcurve).brkend=brkend;
            handles.Record(handles.D.currentcurve).brkstrt=brkstrt;
            handles.Record(handles.D.currentcurve).grtzero=grtzero;
            handles.Record(handles.D.currentcurve).dstt=dstt;
            handles.Record(handles.D.currentcurve).peff=peff;
            guidata(hObject, handles);
        else
            %unbinding event points
            set(handles.Loading_Text,'String','Please select the unbinding event points')
            drawnow
            axes(handles.axes1)
            axis(orig_axis)
            datapoints=myginput(1);
            k = dsearchn([RETx RETy],datapoints);
            hold on
            plot(RETx(k),RETy(k),'mo')
            plot(RETx(k),RETy(k),'mx')
            drawnow
            hold off
            datapoints=myginput(1);
            k(2) = dsearchn([RETx RETy],datapoints);
            if k(2)<k(1)
                k=wrev(k);
            end
            
            %keff
            dend=k(1);
            found=0;
            pc=dend;                            %pointcheck
            while found==0
                pc=pc-1;
                if pc==0
                    found=1;
                    dstt=1;
                    pc=1;
                elseif ismember(RETx(pc),RETx(handles.Record(handles.D.currentcurve).brkend))
                    found=1;
                    dstt=pc;
                end
                dstback=RETx(pc)-RETx(dend);
                if (dstback)>handles.D.keffdist
                    found=1;
                    dstt=pc;
                end
            end
            peff=polyfit(RETx(dstt:dend),RETy(dstt:dend),1);
            
            %Bringing all data into proper units
            FDiff=RETy(k(2))-RETy(k(1));
            Keff=peff(1);
            
            %WLC Model
            if handles.D.keffmodel==2
                dend=k(1);
                found=0;
                pc=dend;                            %pointcheck
                grtzero=handles.Record(handles.D.currentcurve).grtzero;
                
                %Finding the distance back from each unbinding event that is
                %either the input distance or the previous unbinding event.
                while found==0
                    pc=pc-1;
                    if pc==0
                        found=1;
                        dstt=1;
                        pc=1;
                    elseif ismember(RETx(pc),RETx(handles.Record(handles.D.currentcurve).brkend)) || pc==grtzero(1)
                        found=1;
                        dstt=pc+1;
                    end
                    dstback=RETx(pc)-RETx(dend);
                    if (dstback)>handles.D.wlcdist
                        found=1;
                        dstt=pc;
                    end
                end
                
                %Data to fit
                xdfit=(RETx(grtzero(1))-RETx(dstt:dend));
                fdfit=RETy(grtzero(1))-(RETy(dstt:dend));
                %Constants
                kb=1.3806488*10^(-2);
                T=305.15;
                
                %Initial guess, and bounds for the persistence length
                %and countour length, L(1) and L(2) respectively
                Li=[xdfit(end)/10 abs(xdfit(end))*1.05];
                Llb=[0 xdfit(end)];
                Lub=[xdfit(end) 2*xdfit(end)];
                
                %WLC and curvefit
                wlcfunc=@(L,xd)((kb.*T)./L(1)).*((1./(4.*(1-(xd./L(2))).^2))-(1./4)+(xd./L(2)));
                opts = optimset('Display','off','TolFun',1e-7,'TolX',1e-7);   %do not output a writeup
                Lf=lsqcurvefit(wlcfunc,Li,xdfit,fdfit,Llb,Lub,opts);
                
                handles.Record(handles.D.currentcurve).Persistence_L=[handles.Record(handles.D.currentcurve).Persistence_L Lf(1)];
                handles.Record(handles.D.currentcurve).Contour_L=[handles.Record(handles.D.currentcurve).Contour_L Lf(2)];
                
                WLCxspace=linspace(RETx(grtzero(1)),RETx(dstt));
                WLCfuncspace=linspace(0,RETx(grtzero(1))-RETx(dstt));
                WLCresult=RETy(grtzero(1))-wlcfunc(Lf,WLCfuncspace);
                
                WLCxspace_2=linspace(RETx(dstt),RETx(dend));
                WLCfuncspace_2=linspace(RETx(grtzero(1))-RETx(dstt),RETx(grtzero(1))-RETx(dend));
                WLCresult_2=RETy(grtzero(1))-wlcfunc(Lf,WLCfuncspace_2);
                
                %K-Eff calculation
                distb=handles.D.keffdist;
                dbcto=WLCxspace_2(end)+distb;
                LinLi=WLCxspace_2<dbcto;
                
                keff_xsp=WLCxspace_2(LinLi);
                keff_ysp=WLCresult_2(LinLi);
                
                Keff=(keff_ysp(1)-keff_ysp(end))/(keff_xsp(1)-keff_xsp(end));
            end
            
            Ldistance=RETx(handles.Record(handles.D.currentcurve).grtzero)-RETx(k(1));
            Steepness=((RETy(k(2))-RETy(k(1)))/(-RETx(k(2))+RETx(k(1))))*1000;
            Breaklength=(-RETx(k(2))+RETx(k(1)));
            brkend=k(2);
            brkstrt=k(1);
            
            handles.Record(handles.D.currentcurve).CurveNumber=[handles.Record(handles.D.currentcurve).CurveNumber handles.D.currentcurve];
            handles.Record(handles.D.currentcurve).Force=[handles.Record(handles.D.currentcurve).Force FDiff];
            handles.Record(handles.D.currentcurve).Keff=[handles.Record(handles.D.currentcurve).Keff Keff];
            handles.Record(handles.D.currentcurve).Steepness=[handles.Record(handles.D.currentcurve).Steepness Steepness];
            handles.Record(handles.D.currentcurve).Ldistance=[handles.Record(handles.D.currentcurve).Ldistance Ldistance];
            handles.Record(handles.D.currentcurve).Breaklength=[handles.Record(handles.D.currentcurve).Breaklength Breaklength];
            handles.Record(handles.D.currentcurve).brkend=[handles.Record(handles.D.currentcurve).brkend brkend];
            handles.Record(handles.D.currentcurve).brkstrt=[handles.Record(handles.D.currentcurve).brkstrt brkstrt];
            handles.Record(handles.D.currentcurve).dstt=[handles.Record(handles.D.currentcurve).dstt dstt];
            handles.Record(handles.D.currentcurve).peff=[handles.Record(handles.D.currentcurve).peff; peff];
            guidata(hObject, handles);
        end
        
    end
    
end

hold off

set(handles.Loading_Text,'String','Manual mode process complete')
drawnow

%This behaviour displays the calculated data but does not save it
%anywhere. It is meant for user review and is the generally
%accessible mode of the GUI.

%Display Curve Notes
Curvenotes=sprintf(Curvenotes);
set(handles.CurveNotes_Print,'String',Curvenotes)

%Display Calculated Data
calcnotes='Manually Selected Data:\n';
YoungsMod_str1=['Youngs Modulus (Pa): ' num2str(handles.Record(handles.D.currentcurve).YoungsMod) '\n'];
FDiff_str1=['Unbinding Force (pN): ' num2str(handles.Record(handles.D.currentcurve).Force) '\n'];
Keff_str1=['K-eff (pN/nm): ' num2str(handles.Record(handles.D.currentcurve).Keff) '\n'];
Persistence_L_str1=['Persistence Length(nm): ' num2str(handles.Record(handles.D.currentcurve).Persistence_L) '\n'];
Contour_L_str1=['Contour Length (nm): ' num2str(handles.Record(handles.D.currentcurve).Contour_L) '\n'];
Steepnesss_str1=['Steepness (pN/nm): ' num2str(handles.Record(handles.D.currentcurve).Steepness) '\n'];
Ldistance_str1=['L-Distance (nm): ' num2str(handles.Record(handles.D.currentcurve).Ldistance) '\n'];
Breaklength_str1=['Unbinding Length (nm): ' num2str(handles.Record(handles.D.currentcurve).Breaklength) '\n'];
calcnotes=sprintf([calcnotes YoungsMod_str1 FDiff_str1 Keff_str1 Persistence_L_str1 Contour_L_str1 Steepnesss_str1 Ldistance_str1 Breaklength_str1]);
set(handles.CurveNotes_display,'String',calcnotes)

%Display Saved Data
savednotes='Saved Data:\n';
YoungsMod_str2=['Youngs Modulus (Pa): ' num2str(handles.Record(handles.D.currentcurve).YoungsMod) '\n'];
FDiff_str2=['Unbinding Force (pN): ' num2str(handles.Record(handles.D.currentcurve).Force) '\n'];
Keff_str2=['K-eff (pN/nm): ' num2str(handles.Record(handles.D.currentcurve).Keff) '\n'];
Persistence_L_str2=['Persistence Length(nm): ' num2str(handles.Record(handles.D.currentcurve).Persistence_L) '\n'];
Contour_L_str2=['Contour Length (nm): ' num2str(handles.Record(handles.D.currentcurve).Contour_L) '\n'];
Steepnesss_str2=['Steepness (pN/nm): ' num2str(handles.Record(handles.D.currentcurve).Steepness) '\n'];
Ldistance_str2=['L-Distance (nm): ' num2str(handles.Record(handles.D.currentcurve).Ldistance) '\n'];
Breaklength_str2=['Unbinding Length (nm): ' num2str(handles.Record(handles.D.currentcurve).Breaklength) '\n'];
savednotes=sprintf([savednotes YoungsMod_str2 FDiff_str2 Keff_str2 Persistence_L_str2 Contour_L_str2 Steepnesss_str2 Ldistance_str2 Breaklength_str2]);
set(handles.text18,'String',savednotes)

%Plot Force-Curve and Calculated Data
axes(handles.axes1)
plot(RETx,RETy,'b','LineWidth',1)
hold on
plot(EXTx,EXTy,'r','LineWidth',1)
xmax=max([max(RETx) max(EXTx)]);
xmin=min([min(RETx) min(EXTx)]);
ymax=max([max(RETy) max(EXTy)]);
ymin=min([min(RETy) min(EXTy)]);
axis([xmin xmax ymin ymax])

%Plotting stiffness
if isempty(handles.Record(handles.D.currentcurve).func)==0
    ConP=handles.Record(handles.D.currentcurve).ContactPoint;
    StpP=handles.Record(handles.D.currentcurve).pltend;
    fcur=EXTx(ConP);
    plnd=EXTx(handles.Record(handles.D.currentcurve).pltend);
    func=handles.Record(handles.D.currentcurve).func;
    xf=handles.Record(handles.D.currentcurve).xf;
    
    plot(EXTx(ConP:StpP),func(xf,EXTx(ConP:StpP)),'k','LineWidth',1.5)
    plot(fcur,func(xf,fcur),'kx')
    plot(fcur,func(xf,fcur),'ko')
    plot(plnd,func(xf,plnd),'gx')
    plot(plnd,func(xf,plnd),'go')
end

%Plotting unbinding events
breaks=length(handles.Record(handles.D.currentcurve).Force);
for pc=1:breaks
    brkstrt=handles.Record(handles.D.currentcurve).brkstrt(pc);
    brkend=handles.Record(handles.D.currentcurve).brkend(pc);
    dstt=handles.Record(handles.D.currentcurve).dstt(pc);
    peff=handles.Record(handles.D.currentcurve).peff(pc,:);
    
    
    
    plot(RETx(brkstrt:brkend),RETy(brkstrt:brkend),'m','LineWidth',1)
    plot(RETx(handles.Record(handles.D.currentcurve).grtzero),RETy(handles.Record(handles.D.currentcurve).grtzero),'o','Color',[1 0.35 0])
    plot(RETx(handles.Record(handles.D.currentcurve).grtzero),RETy(handles.Record(handles.D.currentcurve).grtzero),'x','Color',[1 0.35 0])
    Xkeff=RETx(dstt:brkstrt);
    if handles.D.keffmodel==1
        LINy=polyval(peff,Xkeff);
        plot(Xkeff,LINy,'Color',[0.2 0.95 0.65],'LineWidth',1)
    elseif handles.D.keffmodel==2
        kb=1.3806488*10^(-2);
        T=305.15;
        wlcfunc=@(L,xd)((kb.*T)./L(1)).*((1./(4.*(1-(xd./L(2))).^2))-(1./4)+(xd./L(2)));
        grtzero=handles.Record(handles.D.currentcurve).grtzero;
        Lf=[handles.Record(handles.D.currentcurve).Persistence_L(pc) handles.Record(handles.D.currentcurve).Contour_L(pc)];
        dend=brkstrt;
        WLCxspace=linspace(RETx(grtzero),RETx(dstt));
        WLCfuncspace=linspace(0,RETx(grtzero)-RETx(dstt));
        WLCresult=RETy(grtzero)-wlcfunc(Lf,WLCfuncspace);
        
        WLCxspace_2=linspace(RETx(dstt),RETx(dend));
        WLCfuncspace_2=linspace(RETx(grtzero)-RETx(dstt),RETx(grtzero)-RETx(dend));
        WLCresult_2=RETy(grtzero)-wlcfunc(Lf,WLCfuncspace_2);
        
        %hold off
        plot(WLCxspace,WLCresult,'Color',[0.2 0.95 0.65],'LineStyle','--','LineWidth',1.5)
        plot(WLCxspace_2,WLCresult_2,'Color',[0.2 0.95 0.65],'LineStyle','-','LineWidth',1.5)
    end
end

%Setting plotting to familiar handles with the reversed x-direction
%as well as labeling the axes
set(gca,'xdir','reverse')
title([handles.DataFile{handles.D.currentcurve,5}],'Interpreter', 'none');
xlabel('Z-sensor (nm)')
ylabel('Force (pN)')
hold off




guidata(hObject, handles);